# dynamic_discriminant2.praat
# djmw 20050512

procedure remove2 id1 id2
  select id1
  plus id2
  Remove
endproc

procedure remove1 id
  select id
  Remove
endproc

datadir$ = "/home/david/tex/thesis/data/"

call readtest barks_total_frame123_mf

call readtest barks_total_frame123_mf_cog_corrected

procedure readtest name$
   Read from file... 'datadir$''name$'.TableOfReal
   t123 = selected ("TableOfReal")
   Rename... t123

   Read from file... 'datadir$''name$'_meansperspeaker.TableOfReal
   tm123 = selected ("TableOfReal")
   Rename... tm123

   call testdis t123 tm123

   call remove2 t123 tm123
endproc  

procedure testdis t123_id tm123_id

  select tfull_id
  # Extract frame 2
  Extract column ranges... 19:36
  t2 = selected ("TableOfReal")
  Rename... t2
  
  select tm123_id
  # Extract frame 2
  Extract column ranges... 19:36
  tm2 = selected ("TableOfReal")
  Rename... tm2
  
  printline Train: M-L-A Test: M-T-A
  call split_test t2 1 40468 40469 54357
  call split_test t123_id 1 40468 40469 54357

  printline Train: F-L-A Test: F-T-A
  call split_test t2 54358 71352 71353 78374
  call split_test t123_id 54358 71352 71353 78374
  
  printline Train: M-L-S Test: M-T-S
  call split_test tm2 1 6008 6009 8078
  call split_test tm123_id 1 6008 6009 8078

  printline Train: F-L-S Test: F-T-S
  call split_test tm2 8079 10568 10569 11579
  call split_test tm123_id 8079 10568 10569 11579

  printline Train: M-L-S Test: M-T-A
  call split1 tm2 1 6008
  learn = ts1
  call split1 t2 1 40468
  test = ts1
  call test learn test
  call remove2 learn test

  printline Train: F-L-S Test: F-T-A
  call split1 tm2 8079 10568
  learn = ts1
  call split1 t2 71353 78374
  test = ts1
  call test learn test
  call remove2 learn test     
endproc

procedure split1 t_id index1 index2
  select t_id
  Extract row ranges... 'index1':'index2'
  ts1 = selected ("TableOfReal")
endproc

procedure test2 t1_id t2_id
  for i to 2
    select t'i'_id
    name1$ = selected$ ("TableOfReal")
    To Discriminant
    dis'i' = selected ("Discriminant")
    for j to 2
      select t'j'_id
      name2$ = selected$ ("TableOfReal")
      plus dis'i'
      To ClassificationTable... y y
      ct = selected ("ClassificationTable")
      To Confusion
      conf = selected ("Confusion")
      fc = Get fraction correct
      printline 'name1$' 'name2$' fc='fc'
      select ct
      plus conf
      Remove
    endfor
    select dis'i'
    Remove
  endfor
endproc
