#multiplexer-decision-regions

# we have to run this script several times to get a good decision boundary.

Erase all

# Create data for multiplexer
Create TableOfReal... mul 4 2
Set value... 1 1 0
Set value... 1 2 0
Set value... 2 1 0
Set value... 2 2 0.9
Set value... 3 1 0.9
Set value... 3 2 0
Set value... 4 1 0.9
Set value... 4 2 0.9

Set row label (index)... 1 1000
Set row label (index)... 2 0100
Set row label (index)... 3 0010
Set row label (index)... 4 0001

# create multiplexer
Split into Pattern and Categories... 0 0 0 0
select TableOfReal mul
Remove
select Pattern mul
plus Categories mul
To Feedforward Net... 1 2 no
Rename... mul

#learn

plus Pattern mul
plus Categories mul
Learn (SM)... 1000 1e-15 minimum squared error

# draw decision regions for the 4 end nodes.

vx = 4
n = 3
 
nx = 100
dx = 1 / nx;
x1 = dx / 2
ny = nx
dy = dx
y1 = dy / 2

Create Pattern with zeroes... input 2 nx*ny
for j to nx
  for i to ny
    r = (j-1)*nx + i
    Set value... r 1 (j-1)*dx+x1
    Set value... r 2 (i-1)*dy+y1
  endfor
endfor
 
Create Matrix... region 0 1 nx dx x1 0 1 ny dy y1 0
dvx = vx / (n + 1)
dvy = dvx

vy = dvx / 4 + 2 * (dvx + dvx / 4)

vy1 = dvy / 4
node = 1
for irow to 2
  vy2 = vy1 + dvy
  vx1 = dvx / 4
  for icol to 2
    vx2 = vx1 + dvx
    select Pattern input
    plus FFNet mul
    To Activation... 4
    Rename... mul
    select Matrix region
    Formula... Activation_mul[(row-1)*nx+col,'node']
    
    Viewport... vx1 vx2 vy1 vy2
    Font size... 1
    Paint image... 0 0 0 0 0 0
    if node=1
      lab$ = "(a)"
    elsif node=2
      lab$ = "(b)"
    elsif node=3
      lab$ = "(c)"
    else
      lab$ = "(d)"
    endif
    Text special... 0.5 Centre -0.2 Half Helvetica 10 0 'lab$'
    vx1 = vx2 + dvx / 4
    node += 1
    select Activation mul
#    Remove
  endfor
  vy1 = vy2 + dvy / 4
endfor

select FFNet mul
vx1 = dvx/4 +2*(dvx+dvx/4)
vx2 = vx1 + dvx
vy1 = vy / 2 - dvy / 2
vy2 = vy1 + dvy
Viewport... vx1 vx2 vy1 vy2
Draw topology

#select FFNet mul
#plus Pattern input
#plus Pattern mul
#plus Categories mul
#plus Matrix region
#Remove

Font size... 1
Viewport... 0 vx 0 vy
Draw inner box
file$="/home/david/tex/thesis/nn-aspects/multiplexer-decision-regions-try"
Write to EPS file... 'file$'.eps
system epstopdf --outfile='file$'.pdf 'file$'.eps









