# pcs_PCA_LDA_m_f.praat
# djmw 20040622

procedure vp1
  a = 1/2.54
  x0 = 1.5
  x1 = x0
  dx = 5
  x2 = x1 + dx
  y1 = 1
  dy = 3
  y2 = y1 + dy
  Select inner viewport... a*x1 a*x2 a*y1 a*y2
endproc
procedure vp2
  x1 = x2 + 2
  x2 = x1 + dx
  Select inner viewport... a*x1 a*x2 a*y1 a*y2
endproc
procedure vp3 yscale
  x1 = x0
  dx2 = dx + 2 + dx
  x2 = x1 + dx2
  y1 = y2 + 2
  y2 = y1 + yscale * dx2
  Select inner viewport... a*x1 a*x2 a*y1 a*y2
endproc
procedure vpall
  x1 = x0
  x2 = x1 + dx + 2 + dx
  y1 = 1
  Select inner viewport... a*x1 a*x2 a*y1 a*y2
endproc

datadir$ = "/home/david/tex/thesis/data/"
savedir$ = "/home/david/tex/thesis/nn-bias2/"

Read from file... 'datadir$'barks_total_frame2_mf_meansperspeaker.TableOfReal
mf = selected ("TableOfReal")
Read from file... 'datadir$'barks_total_frame2_mf_meansperspeaker_index.TableOfReal
index = selected ("TableOfReal")

# speaker 1-438 male, 439-630 female
lowerindexm = Get value... 1 1
upperindexm= Get value... 438 2
lowerindexf = Get value... 439 1
upperindexf= Get value... 630 2


select mf
Extract row ranges... 'lowerindexm':'upperindexm'
m = selected ("TableOfReal")


select mf
Extract row ranges... 'lowerindexf':'upperindexf'
f = selected ("TableOfReal")

select m
To PCA
m_pca = selected ("PCA")

select m
To Discriminant
m_dis =  selected ("Discriminant")

select f
To PCA
f_pca = selected ("PCA")

select f
To Discriminant
f_dis =  selected ("Discriminant")

call vp1

select m_pca
Draw eigenvector... 1 n 0 0 -1 1 1 + y y
select f_pca
Dotted line
Draw eigenvector... 1 n 0 0 -1 1 1 + y n
Plain line
Text top... n (a) PCA: Eigenvector 1

call vp2

select m_dis
Draw eigenvector... 1 n 0 0 -1 1 1 + y y
select f_dis
Dotted line
Draw eigenvector... 1 n 0 0 -1 1 1 + y n
Plain line
Text top... n (b) LDA: Eigenvector 1

call vp_next

select m_pca
Draw eigenvector... 2 n 0 0 -1 1 1 + y y
select f_pca
Dotted line
Draw eigenvector... 2 n 0 0 -1 1 1 + y n
Plain line
Text top... n (c) PCA: Eigenvector 2

call vp_next

select m_dis
Draw eigenvector... 2 n 0 0 -1 1 1 + y y
select f_dis
Dotted line
Draw eigenvector... 2 n 0 0 -1 1 1 + y n
Plain line
Text top... n (d) LDA: Eigenvector 2


call vp_initr 12 6 2 1 1

Font size... 8

select f_dis
Extract group centroids
f_centroid = selected ("TableOfReal")

select m_dis
Extract group centroids
m_centroid = selected ("TableOfReal")

# projection of female data in male pca-space

select m_pca
Invert eigenvector... 1
plus m_centroid
To Configuration... 2
m_conf = selected ("Configuration")

select m_pca
plus f_centroid
To Configuration... 2
f_conf = selected ("Configuration")

call vp_next

select m_conf
Draw... 1 2 60 130 80 120 10 y + y
select f_conf
Draw... 1 2 60 130 80 120 7 y + n
Text top... n (e) PCA

# projection of female data in male lda-space

select m_dis
plus m_centroid
To Configuration... 2
m_conf = selected ("Configuration")

select m_dis
plus f_centroid
To Configuration... 2
f_conf = selected ("Configuration")


call vp_next

select m_conf
Set column label (index)... 1 Eigenvector 1
Set column label (index)... 2 Eigenvector 2
Draw... 1 2 -45 0 0 35 10 y + y

select f_conf
Draw... 1 2 -45 0 0 35 7 y + n
Text top... n (f) LDA

#call save pcs_PCA_LDA_m_f

