# f0_is_zero_examples.praat
# djmw 20040701

datadir$ = "/home/TIMIT/train/dr1/mcpm0/"
savedir$ = "/home/david/tex/thesis/timit/"
include /home/david/tex/praat_procedures.praat
# 
# select usage,sp_dr,sp_sex,sp_id,st_id,ph_id,ph_tmin,ph_tmax from inventory where num = 69482
#  trn   | 1     | m      | cpm0  | sa1   | ax-h  | 0.543063 |  0.5775

Read from file... 'datadir$'sa1.wav
s = selected ("Sound")
Read from file... 'datadir$'sa1.phn
g = selected ("TextGrid")
Remove tier... 2

call vp_init 12 16 1 5 1
Font size... 8
call vp_margins 0 0 0.25 0.25
call vp_next

select s
Scale peak... 0.99
call  draw_sound_no_time 's'
Text top... n She had your dark suit in greasy wash water all year

 
procedure draw_sound_no_time ps
  select ps
  t1 = Get starting time
  t2 = Get finishing time
  Draw... 0 0 -1 1 n curve
  Draw inner box
  One mark bottom... t1 y y n
  One mark bottom... t2 y y n
  One mark left... -1 y y n
  One mark left... 1 y y n
endproc

procedure draw_sound_textgrid_no_time ps pg
  select ps
  t1 = Get starting time
  t2 = Get finishing time
  plus pg
  Draw... 0 0 y y n
  Draw inner box
  One mark bottom... t1 y y n
  One mark bottom... t2 y y n
  Marks bottom every... 1 0.01 n y n
endproc
 
procedure replace_label pg s$ se$
  select pg
  ni = Get number of intervals... 1
  for j to ni
    label$ = Get label of interval... 1 j
    if label$ = s$
#      fat$ = "##"+"'label$'"+"#"
      fat$ = "\\s{"+"'label$'"+"}"
      Set interval text... 1 j 'se$'
    endif
  endfor
endproc

procedure draw_parts ps pg t1 t2 s$ se$
  select pg
  Extract part... t1 t2 y
  gp = selected ("TextGrid")
  call replace_label gp 's$' 'se$'
  select ps
  Extract part... t1 t2 Rectangular 1 y
  sp = selected ("Sound")
  Scale peak... 0.99
  call draw_sound_textgrid_no_time 'sp' 'gp'
#  Draw... 0 0 y y y
  select ps
  plus gp
  Remove
endproc

# select usage,sp_dr,sp_sex,sp_id,st_id,ph_id,ph_tmin,ph_tmax from inventory where num = 69482
#  trn   | 1     | m      | cpm0  | sa1   | ax-h  | 0.543063 |  0.5775
p11 = 0.543063
p12 = 0.5775
# select usage,sp_dr,sp_sex,sp_id,st_id,ph_id,ph_tmin,ph_tmax from inventory where num = 69485
# trn   | 1     | m      | cpm0  | sa1   | aa    |  0.6525 | 0.767563
p21 = 0.6525
p22 = 0.767563
# select usage,sp_dr,sp_sex,sp_id,st_id,ph_id,ph_tmin,ph_tmax from inventory where num = 69492
# trn   | 1     | m      | cpm0  | sa1   | ax-h  |  1.4425 | 1.48563
p31 = 1.4425
p32 = 1.48563
# select usage,sp_dr,sp_sex,sp_id,st_id,ph_id,ph_tmin,ph_tmax from inventory where num = 69499
# trn   | 1     | m      | cpm0  | sa1   | ix    | 1.83025 | 1.86681
p41 = 1.83025
p42 = 1.86681

t11 = 0.48
t12 = 0.59
t21 = 0.62
t22 = 0.83
t31 = 1.38
t32 = 1.55
t41 = 1.77
t42 = 1.92

# the vowel labels of interest 
s1$ = "ax-h"
s2$ = "aa"
s3$ = "ax-h"
s4$ = "ix"

# the vowel labels of interest and emphasised
se1$ = "AX-H"
se2$ = "AA"
se3$ = "AX-H"
se4$ = "IX"

abc1$ ="(a)"
abc2$ ="(b)"
abc3$ ="(c)"
abc4$ ="(d)"

for i to 4
  t1 = t'i'1
  t2 = t'i'2
  phon$ = s'i'$
  One mark bottom... t1 n y y
  One mark bottom... t2 n y y
  tm = p'i'1 + (p'i'2-p'i'1)/2
  part$ = abc'i'$
  One mark bottom... tm n n n 'part$'
endfor


for i to 4
  call vp_next
  t1 = t'i'1
  t2 = t'i'2
  phon$ = s'i'$
  phone$ = se'i'$
  abc$ = abc'i'$
  call draw_parts 's' 'g' 't1' 't2' 'phon$' 'phone$'
  Text top... n 'abc$'
endfor

call save f0_is_zero_examples
