# sekey-hanson-filters.praat
# 20050409 Last modification

datadir$ = "/data/TIMIT/train/dr1/mcpm0/"
savedir$ = "/home/david/tex/thesis/timit/"
include /home/david/tex/praat_procedures.praat

Read from file... 'datadir$'sa1.wav
s = selected ("Sound")

To BarkFilter... 0.025 0.005 1 1 19
b = selected ("BarkFilter")

call vp_init 12 15 1 3 1
Font size... 8
call vp_next

Draw frequency scales... Hertz 0 8000 Bark 0 0 y
Marks bottom every... 1 1000 n y n
Marks left every... 1 5 n y n
One mark bottom... 650 y y y
Text top... n (a)
call vp_next

Draw filter functions... 1 18 Bark 0 0 y 0 0 n
Draw inner box
Marks left every... 1 10 y y n

One mark bottom... 1 y n y
One mark bottom... 18 y n y
Marks bottom every... 1 1 n y n
Text top... n (b)
Text bottom... y Frequency (Bark)
call vp_next

Draw filter functions... 1 18 Hertz 0 8000 y 0 0 y
Marks bottom every... 1 1000 n y n
hz = Get frequency in Hertz... 18 Bark
hz$ = fixed$ (hz, 0)
One mark bottom... 'hz$' y y y
Text top... n (c)

call save sekey-hanson-filters

pause
call vp_init 12 12 1 2 1
Font size... 8
call vp_next

select b

Paint cells... 0 0 0 0 0 0
t = Get starting time
One mark bottom... t y y n
t = Get finishing time
One mark bottom... t y y n
Text bottom... y Time (s)
One mark left... 1 y y n
One mark left... 18 y y n
Text left... y Filter number
Text top... n (a)
Marks left every... 1 1 n y n
Marks bottom every... 1 1 n y n

select s
fmax = 650*sinh (18/7)
To Spectrogram... 0.025 fmax 0.005 20 Gaussian

call vp_next
Paint... 0 0 0 0 100 y 50 6 0 y
Text top... n (b)
Marks left every... 1 1000 n y n
One mark bottom... 1.0 n y n 1.0
One mark bottom... 2.0 n y n 2.0
call save sa1-bark-spectrograms